/*
 * Copyright(C) 2012 OPTOELECTRONICS CO., LTD. All rights reserved.
 */
package jp.co.opto.opn2002.sdk.sample;

import java.util.Iterator;
import java.util.Set;

import jp.co.opto.opnsdk.BluetoothServiceState;
import jp.co.opto.opnsdk.Opn2002BluetoothService;
import jp.co.opto.opnsdk.callback.GetFirmwareVersionCallback;
import jp.co.opto.opnsdk.callback.VoidCallback;
import jp.co.opto.opnsdk.observer.IBluetoothObserver;
import android.app.Activity;
import android.bluetooth.BluetoothDevice;
import android.os.Bundle;
import android.text.method.ScrollingMovementMethod;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class FirstAppActivity extends Activity implements IBluetoothObserver{
    
	private Opn2002BluetoothService mBTService;
	
	private TextView mTextView;
	private TextView mStatus;
	private Button mBtnConn;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);        
    
        mBTService = Opn2002BluetoothService.getInstance(this);
  
        mTextView = (TextView)findViewById(R.id.textview_inputed);
        mTextView.setMovementMethod(ScrollingMovementMethod.getInstance());
        mStatus = (TextView)findViewById(R.id.textView_status);
	
		// ڑ{^
		mBtnConn = (Button)findViewById(R.id.button_connect);
		mBtnConn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				
				// ڑ҂󂯂~
				mBTService.stop();
				
				//yAOς݃foCX擾
				Set<BluetoothDevice> set = mBTService.getPairedDevices();
				//yAOς݃foCX疼OuOPN-2002ṽfoCX1擾Đڑ
				if(set.size() > 0) {
					Iterator<BluetoothDevice> it = set.iterator();
					while(it.hasNext()){
						BluetoothDevice device = it.next();
						if(device.getName() != null && device.getName().indexOf("OPN")>=0){
							//ڑJn
							mBTService.connect(device, false);
							try  
							{
								java.lang.Thread.sleep(100);//BluetoothServiceStateconnectedɂȂ܂ł̃fBC
							}
							catch(Exception e)
							{
							}
							//ڑł猟I
							if (mBTService.getState()==BluetoothServiceState.connected)
								break;	
						}
					}
				}

				//ڑłȂڑ҂󂯂ĊJ
				if (mBTService.getState()!=BluetoothServiceState.connected)
					mBTService.start();

			}
		});
		
		
		// ؒf{^
		Button btnDisconn = (Button)findViewById(R.id.button_disconnect);
		btnDisconn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				mBTService.stop();
			}
		});
		
		// o[W{^
		Button btnCommand = (Button)findViewById(R.id.button_command);
		btnCommand.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				mBTService.getFirmwareVersion(new GetFirmwareVersionCallback() {
					
					@Override
					protected void callbackExecute(String arg0) {
						receive(arg0+"\r");						
					}
				});
			}
		});
		
		// uU[ON
		Button btnBuzzerOn = (Button)findViewById(R.id.button_buzzer_on);
		btnBuzzerOn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				mBTService.write("W8", new VoidCallback() {
					
					@Override
					protected void callbackExecute(Void arg0) {
						if(getIsError()){
							showErrorMessage(getResources().getString(R.string.msg_conf_change_error));	//G[bZ[W\
						}
						else{
							showMessage(getResources().getString(R.string.label_buzzer_on));
						}
					}
				});
			}
		});
		
		// uU[OFF
		Button btnBuzzerOff = (Button)findViewById(R.id.button_buzzer_off);
		btnBuzzerOff.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				mBTService.write("W0", new VoidCallback() {
					
					@Override
					protected void callbackExecute(Void arg0) {
						if(getIsError()){
							showErrorMessage(getResources().getString(R.string.msg_conf_change_error));	//G[bZ[W\
						}
						else{
							showMessage(getResources().getString(R.string.label_buzzer_off));
						}
					}
				});
			}
		});
	}
    
	private void showErrorMessage(String msg){
		Toast.makeText(this, msg, Toast.LENGTH_LONG).show();
	}
	
	private void showMessage(String msg){
		Toast.makeText(this, msg, Toast.LENGTH_SHORT).show();
	}
	
	@Override
	protected void onStart() {
        super.onStart();

        if(mBTService != null){
        	//Android[BluetoothT|[gĂȂH
        	if (!mBTService.isEnabled()) {
                Toast.makeText(this, "Bluetooth is not available", Toast.LENGTH_LONG).show();
                finish();
                return;
            }
        	
        	//KvɉāABluetoothLɂݒʂ\
        	mBTService.showBluetoothSetting(this);
        	
        	if(mBTService.getState() == BluetoothServiceState.none){
        		mBTService.start();
        	}
        }
	}
	
    @Override
    protected void onResume() {
        super.onResume();
        
    	if(mBTService != null){
        	mBTService.addObserver(this);    		
    	}
    	refreshStatusLabel();
	}

    @Override
    protected void onPause(){
    	super.onPause();
    	
    	if(mBTService != null){
        	mBTService.removeObserver(this);    		
    	}
    }
    
    @Override
    protected void onDestroy(){
    	super.onDestroy();
        
		mBTService.stop();
    }

	@Override
	public void connectFailed() {
		Toast.makeText(this, "connection failed ", Toast.LENGTH_LONG).show();		
	}

	@Override
	public void connected(BluetoothDevice arg0) {
		Toast.makeText(this, "connected", Toast.LENGTH_LONG).show();
		mBTService.enableAckNak();  // ! Opn2002BluetoothServicegpۂ͂Ȃ炸ڑ enableAckNak()sĂB 
		refreshStatusLabel();
	}

	@Override
	public void connectionLost() {
		Toast.makeText(this, "connection lost", Toast.LENGTH_LONG).show();
		refreshStatusLabel();
	
		mBTService.start();
	}

	@Override
	public void receive(String data) {
		if(mTextView != null && data != null){
			/* sR[hϊ܂B@*/
			data = data.replace((char)0x0D, (char)0x0A);
			/* R}hACK/NAKĂꍇ폜܂B@*/
			data = data.replaceAll(""+(char)0x6, "");
			data = data.replaceAll(""+(char)0x15, "");
			mTextView.append(data);
	        
			if (mTextView.getLineCount()>mTextView.getMaxLines())
			{
				int y = mTextView.getLayout().getLineTop(mTextView.getLineCount()-mTextView.getMaxLines());
				mTextView.scrollTo(0, y);
			}
		}
	}
	
	private void refreshStatusLabel(){
		if(mBTService.getState().compareTo(BluetoothServiceState.connected) == 0){
			mStatus.setText(R.string.label_connected);
			mBtnConn.setEnabled(false);
		}
		else{
			mStatus.setText(R.string.label_not_connected);			
			mBtnConn.setEnabled(true);
		}
	}
}